import { InputFlags, InputArgs, OutputArgs, OutputFlags } from 'cli-flags';
import { Config, ConfigOptions, Plugin, ICommand } from 'cli-engine-config';
import { HTTP } from 'http-call';
import { CLI } from 'cli-ux';
import color = require('./color');
export interface IMockOutput<T extends Command> {
    cmd: T;
    stdout: string;
    stderr: string;
}
export declare class Command implements ICommand {
    topic?: string;
    command?: string;
    name?: string;
    description?: string;
    hidden: boolean;
    usage?: string;
    help?: string;
    aliases: string[];
    _version: any;
    plugin?: Plugin;
    parse: {
        args?: InputArgs;
        flags: InputFlags;
        strict?: boolean;
    };
    readonly id: string;
    static mock<T extends Command>(...argv: string[]): Promise<IMockOutput<T>>;
    static run(config?: ConfigOptions): Promise<Command>;
    config: Config;
    http: typeof HTTP;
    cli: CLI;
    flags: OutputFlags<this['parse']['flags']>;
    argv: string[];
    args: OutputArgs;
    color: typeof color.color;
    constructor(config?: ConfigOptions);
    _run(): Promise<void>;
    init(): Promise<void>;
    run(): Promise<void>;
    done(): Promise<void>;
    buildHelp(): string;
    buildHelpLine(): [string, string | undefined];
}
